//+------------------------------------------------------------------+
//|                                       VoltyChannel_Stop_v2.1.mq4 |
//|                                Copyright  2007, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
//2008fxtsd mod
#property copyright "Copyright  2007, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Chartreuse
#property indicator_color2 Red
#property indicator_color3 Chartreuse
#property indicator_color4 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//---- input parameters
extern int     MA_Price              = 0; //Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
extern int     MA_Length             = 1; //MA's Period 
extern int     MA_Mode               = 0; //MA's Method:0-SMA,1-EMA,2-SMMA,3-LWMA  
extern int     ATR_Length            = 10;//ATR's Period
extern double  Kv                    = 4; //Volatility's Factor or Multiplier
extern double  MoneyRisk             = 1; //Offset Factor 
extern bool    usePrice_HiLoBreak    = true;    
extern bool    useMA_HiLoEnvelope    = false;   
extern int     AlertMode             = 0; //0-alert off,1-on
extern int     VisualMode            = 0; //0-lines,1-dots 
extern string  Applied_Price_        = "0-C,1-O,2-H,3-L,4-Median(H+L)/2,5-Typical(H+L+C)/3,6-Weighted(H+L+C+C)/4";
extern string  MAmethod_mode_        = "0-SMA,1-EMA,2-SMMA,3-LWMA";
extern string  Visual_Mode___        = "0-lines,1-dots "; 
extern int     TimeFrame             = 0;
extern string  note_TimeFrames_      = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-currentTF";

//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double UpSignal[];
double DnSignal[];
double smin[];
double smax[];
double trend[];

bool   UpTrendAlert=false, DownTrendAlert=false;
string IndicatorFileName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,UpSignal);
   SetIndexBuffer(3,DnSignal);
   SetIndexBuffer(4,smin);
   SetIndexBuffer(5,smax);
   SetIndexBuffer(6,trend);
   
      if(VisualMode==0)
      {
      SetIndexStyle(0,DRAW_LINE);
      SetIndexStyle(1,DRAW_LINE);
      }
      else
      {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(0,159);
      SetIndexArrow(1,159);
      }
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(2,108);
   SetIndexArrow(3,108);
   
   
           switch(TimeFrame)
   {
      case 1: string TimeFrameStr = "M1" ;  break;
      case 5     :   TimeFrameStr = "M5" ;  break;
      case 15    :   TimeFrameStr = "M15";  break;
      case 30    :   TimeFrameStr = "M30";  break;
      case 60    :   TimeFrameStr = "H1" ;  break;
      case 240   :   TimeFrameStr = "H4" ;  break;
      case 1440  :   TimeFrameStr = "D1" ;  break;
      case 10080 :   TimeFrameStr = "W1" ;  break;
      case 43200 :   TimeFrameStr = "MN1";  break;
      default :      TimeFrameStr = "TF0";
   }

   TimeFrame         = MathMax(TimeFrame,Period());
   IndicatorFileName = WindowExpertName();
   short_name="VoltyChannel_Stop("+MA_Length+","+ATR_Length+","+DoubleToStr(Kv,3)+") "+TimeFrameStr ;
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DnTrend");
   SetIndexLabel(2,"UpSignal");
   SetIndexLabel(3,"DnSignal");
//----
   SetIndexDrawBegin(0,MA_Length+ATR_Length);
   SetIndexDrawBegin(1,MA_Length+ATR_Length);
   SetIndexDrawBegin(2,MA_Length+ATR_Length);
   SetIndexDrawBegin(3,MA_Length+ATR_Length);

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| VoltyChannel_Stop_2                                              |
//+------------------------------------------------------------------+
int start()
  {
   
    int counted_bars=IndicatorCounted();
   int i,shift,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   if (TimeFrame != Period())
   {
      datetime TimeArray[];
         limit = MathMax(limit,TimeFrame/Period());
         ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);


         for(i=0,int y=0; i<limit; i++)
         {
            if(Time[i]<TimeArray[y]) y++;
           
            
   UpBuffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,
                 MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,0,y);
   DnBuffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,
                 MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,1,y);
   UpSignal[i] = iCustom(NULL,TimeFrame,IndicatorFileName,MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,
                 MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,2,y);
   DnSignal[i] = iCustom(NULL,TimeFrame,IndicatorFileName,MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,
                 MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,3,y);
   smin[i]     = iCustom(NULL,TimeFrame,IndicatorFileName,MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,
                 MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,4,y);
   smax[i]     = iCustom(NULL,TimeFrame,IndicatorFileName,MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,
                 MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,5,y);
   trend[i]    = iCustom(NULL,TimeFrame,IndicatorFileName,MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,
                 MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,6,y);

               
      }
   return(0);         
  }
   
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-MA_Length-1; 
   
     
	for(shift=limit;shift>=0;shift--) 
   {	
      if(useMA_HiLoEnvelope)
         {
  double bprice = iMA(NULL,TimeFrame,MA_Length,0,MA_Mode,2,shift);
  double sprice = iMA(NULL,TimeFrame,MA_Length,0,MA_Mode,3,shift);
         }
      else
         {
         bprice = iMA(NULL,TimeFrame,MA_Length,0,MA_Mode,MA_Price,shift);
         sprice = iMA(NULL,TimeFrame,MA_Length,0,MA_Mode,MA_Price,shift);
         }
    
      
	smax[shift] = bprice + Kv*iATR(NULL,TimeFrame,ATR_Length,shift);
   smin[shift] = sprice - Kv*iATR(NULL,TimeFrame,ATR_Length,shift); 
      
       
   trend[shift]=trend[shift+1];
 
      if(usePrice_HiLoBreak)
      {  
      if ( High[shift] > smax[shift+1] ) trend[shift] =  1;
      if ( Low[shift]  < smin[shift+1] ) trend[shift] = -1;
	   }
      else
      {
      if ( bprice > smax[shift+1] ) trend[shift] =  1;
      if ( sprice < smin[shift+1] ) trend[shift] = -1;
	   }
      
      if ( trend[shift] >0 ) 
	   {
	   if( smin[shift] < smin[shift+1]) smin[shift] = smin[shift+1];
	   UpBuffer[shift] = smin[shift] - (MoneyRisk - 1)*iATR(NULL,TimeFrame,ATR_Length,shift);
	   if( UpBuffer[shift] < UpBuffer[shift+1] && UpBuffer[shift+1]!=EMPTY_VALUE) UpBuffer[shift] = UpBuffer[shift+1];
	   if(trend[shift+1] != trend[shift]) UpSignal[shift] = UpBuffer[shift];
	   else UpSignal[shift] = EMPTY_VALUE;
	   DnBuffer[shift] = EMPTY_VALUE;
	   DnSignal[shift] = EMPTY_VALUE;
	   }
	   else
	   if ( trend[shift] <0 ) 
	   {
	   if( smax[shift]>smax[shift+1]) smax[shift] = smax[shift+1];
	   DnBuffer[shift] = smax[shift] + (MoneyRisk - 1)*iATR(NULL,TimeFrame,ATR_Length,shift);
	   if( DnBuffer[shift] > DnBuffer[shift+1]) DnBuffer[shift] = DnBuffer[shift+1];
	   if(trend[shift+1] != trend[shift]) DnSignal[shift] = DnBuffer[shift];
	   else DnSignal[shift] = EMPTY_VALUE;
	   UpBuffer[shift] = EMPTY_VALUE;
	   UpSignal[shift] = EMPTY_VALUE;
	   }
   }
//----------   
   string Message;
   
   if ( trend[2]<0 && trend[1]>0 && Volume[0]>1 && !UpTrendAlert)
	{
	Message = " "+Symbol()+" M"+Period()+": VCS Signal for BUY";
	if ( AlertMode>0 ) Alert (Message); 
	UpTrendAlert=true; DownTrendAlert=false;
	} 
	 	  
	if ( trend[2]>0 && trend[1]<0 && Volume[0]>1 && !DownTrendAlert)
	{
	Message = " "+Symbol()+" M"+Period()+": VCS Signal for SELL";
	if ( AlertMode>0 ) Alert (Message); 
	DownTrendAlert=true; UpTrendAlert=false;
	} 	         
//----	
   return(0);	
}

